from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import commands
import time
import os
 
class Memo(Sensor):

	def __init__(self):
		
		global _; _ = i18n.Translator("memo-sensor")
		
		self.__output = ""
		
		Sensor.__init__(self)
		self._set_config_type("update", TYPE_INT, 30000)
		self._set_config_type("Memo", TYPE_STRING, "~/.gdesklets/memo")
		self._add_timer(1000, self.__on_tick)
		self._add_thread(self.__command_thread)

	def get_configurator(self):
		configurator = self._new_configurator()
		configurator.set_name(_("Memo"))
		configurator.add_title(_("Memo configuration"))
		configurator.add_spin(_("Update every (ms):"), "update",
					_("Updates the display(s) every x milliseconds"),
					50, 3600000)
		configurator.add_entry(_("Memo file:"), "Memo",
					_("Sets the file name"))
		
		return configurator

	def __on_tick(self):
		
		data = self._new_output()
		data.set("value", self.__output)
		self._send_output(data)
		
		return 1

	def __command_thread(self):
		while (1):
			if (self._is_stopped()): break
			
			filename = self._get_config("Memo").replace("~",os.getenv("HOME"))
			
			try :
				fd = open(filename, "r")
				output = fd.read()
				fd.close()
			except :
				output = ""
			
			self.__output = output
			
			update = self._get_config("update")
			time.sleep(update*0.001)
			
def new_sensor(args): return apply(Memo, args)
